unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Memo2: TMemo;
    Memo3: TMemo;
    Button2: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Edit1: TEdit;
    Label5: TLabel;
    Button5: TButton;
    Button6: TButton;
    function lies_passwort:string;
    procedure VerschlMemo(const m1:Tmemo; var m2:Tmemo; passwort:string;
       art:boolean);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

const
  Basis=224; //Ziffern 0,1,2,...,223 ASCII ohne Steuerzeichen
var
  Form1: TForm1;

implementation

{$R *.DFM}

function f(const i,n:integer):integer; //Bijektiv von {0,1,...,Basis}
  //Statt des Csarcodes knnt hier jede beliebige bijektive Funktion stehen
  //Die Umkehrfunktion zum Entschlsseln msste dann explizit angegeben werden
begin
  result:=i+n;
  if result>=Basis then result:=result-Basis; //Falls n>0: Basis->0 Basis+1->1 ...
  if result<0 then result:=result+Basis;  //Falls n<0: ... -2->Basis-2 -1->Basis-1
end;

procedure VerschlEinBuchstabe(var c:char; n:integer); //Csar-Code
  //Verschiebung im ASCII-Bereich 32 bis 255
  //(ASCII-Bereich unter 32 sind Steuerzeichen)
  var i:integer;
begin
  i:=f(ord(c)-32,n);
  c:=char(i+32);
end;

Procedure VerschlZeile(var s:string; passwort:string; art:boolean);
  //art = true: verschlsseln art =false: entschlsseln
  var k,j,n:integer;
begin
  for k:=1 to length(s) do Begin
    j := k mod length(passwort) + 1;
    if art then n := ord(passwort[j]) else n := -ord(passwort[j]);
    VerschlEinBuchstabe(s[k],n);
  End;
end;

function TForm1.lies_Passwort:string;
begin
  if edit1.text='' then edit1.text := 'Bitte Passwort hier eingeben';
  result:=edit1.text;
end;



Procedure Tform1.VerschlMemo(const m1:Tmemo; var m2:Tmemo; passwort:string; art:boolean);
  //const vor m1 spart Speicherplatz (lohnt sich hier):
  //Es wird keine neue Instanz erzeugt
  var i:integer;
      s:string;
begin
  m2.lines.clear;
  for i:=0 to m1.lines.count-1 do Begin
    s:=m1.lines[i];
    verschlZeile(s,passwort,art);
    m2.lines.add(s);
  End;
end;

procedure TForm1.Button1Click(Sender: TObject);
  var s: string;
begin
  s:=lies_passwort;
  VerschlMemo(memo1,memo2,s,true); //verschlsseln
  memo3.Lines.Clear;
end;

procedure TForm1.Button2Click(Sender: TObject);
 var p: string;
begin
  p:=lies_passwort;
  VerschlMemo(memo2,memo3,p,false);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  close;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
 close
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 form1.WindowState := wsmaximized;
 memo1.Text:='Eine Gruppe von Ingenieuren und eine Gruppe von '+
'Mathematikern fahren mit dem Zug zu einer Tagung. Jeder'#13#10+
'der Ingenieure hat seine eigene Fahrkarte, aber die ganze '+
'Gruppe von Mathematikern hat nur eine einzige Karte.'#13#10+
'Pltzlich ruft einer der Mathematiker "Der Schaffner '+
'kommt!", worauf sich alle Mathematiker in eine der'#13#10+
'Toiletten zwngen. Der Schaffner kommt, kontrolliert die '+
'Ingenieure, sieht, da das WC besetzt ist und klopft an'#13#10+
'die Tr : "Die Fahrkarte bitte !". Einer der Mathematiker '+
'schiebt die Fahrkarte unter der Tr durch und der'#13#10+
'Schaffner zieht zufrieden wieder ab.'#13#10+
''#13#10+
'Auf der Rckfahrt beschlieen die Ingenieure, denselben Trick '+
'anzuwenden und sie kaufen nur eine Karte fr die ganze Gruppe.'#13#10+
'Sie sind sehr verwundert, als sie merken, da die Mathematiker '+
'diesmal berhaupt keine Fahrkarte haben...   Wieder ruft'#13#10+
'einer der Mathematiker "Der Schaffner kommt!". Sofort '+
'strzen die Ingenieure auf das eine WC, die Mathematiker'#13#10+
'machen sich etwas gemchlicher auf den Weg zum anderen. '+
'Bevor der letzte Mathematiker die Toilette betritt,'#13#10+
'klopft er bei den Ingenieuren an: "Fahrkarte bitte!"';
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  memo1.Clear;
  memo2.Clear;
  memo3.Clear;
end;

end.
